//  CSIntro_course2005_Lecture_07
//
//  Example 4A
//
//  Two-dimensional arrays and random numbers

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

int main()
{
int m,n;                     // input - size of array (m x n)
float minrow,maxcol;         //output - minimum & maximum
int j,k;                     //internal variables
float h[20][20];             //define array of heights
float mr[20],mc[20];         // row and column arrays

// get data from user
cout<<"\nEnter size of array (integers between 1 and 20):\n";
cout<<"m = ";
cin>>m;
cout<<"n = ";
cin>>n;
cout<<endl;                 //add blank line to output (screen)
srand(time(0));             //initialize random sequence by PC clock

// initialize array values
for (j=0;j<m;j++)
    for (k=0;k<n;k++)
        h[j][k]=1.50+(rand()%600)*0.001;     // random values between 1.500 and 2.099  (height in meters)

// compute minimum of each row
for (j=0;j<m;j++) {
    mr[j]=h[j][0];
    for (k=1;k<n;k++)
        if (mr[j]>h[j][k]) mr[j]=h[j][k];
}

// compute maximum of each column
for (k=0;k<n;k++) {
    mc[k]=h[0][k];
    for (j=1;j<m;j++)
        if (mc[k]<h[j][k]) mc[k]=h[j][k];
}

// display all data
for (j=0;j<m;j++) {
    for (k=0;k<n;k++)
        cout<<h[j][k]<<"\t";
    cout<<"\t"<<mr[j]<<endl; }
cout<<endl;
for (k=0;k<n;k++)
    cout<<mc[k]<<"\t";
cout<<endl;

// compute and display results
minrow=mr[0];
for (j=1;j<m;j++)
    if (minrow<mr[j]) minrow=mr[j];
maxcol=mc[0];
for (k=1;k<n;k++)
    if (maxcol>mc[k]) maxcol=mc[k];

cout<<"\nA = Maximum of row-minimums = "<<minrow;
cout<<"\nB = Minimum of col-maximums = "<<maxcol;
cout<<endl<<"\nAlways holds that  A<=B\n";

system("pause");
return 0;
}
